diff --git a/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index 86a3cc0b2..0634b81e7 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -5,12 +5,12 @@ import static net.minecraft.client.gui.options.components.ButtonComponent.*;
 import java.util.ArrayList;
 import java.util.List;
 
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
@@ -73,7 +73,7 @@ public class AvailableTexturePackListComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (availablePacks.isEmpty()) {
-            mc.fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
+            mc.font.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
         }
         for (int i = 0; i < availablePacks.size(); i++) {
             TexturePackButton button = availablePacks.get(i);
@@ -110,7 +110,7 @@ public class AvailableTexturePackListComponent
     }
 
     private static class TexturePackButton {
-        private GuiButton button;
+        private ButtonElement button;
         public final int index;
         public final TexturePack texturePack;
         public final int height = BUTTON_HEIGHT;
@@ -118,7 +118,7 @@ public class AvailableTexturePackListComponent
         public TexturePackButton(int index, TexturePack texturePack) {
             this.index = index;
             this.texturePack = texturePack;
-            button = new GuiButton(0, 0, 0, 20, 20, "+");
+            button = new ButtonElement(0, 0, 0, 20, 20, "+");
         }
 
         public boolean isClickable() {
@@ -127,7 +127,7 @@ public class AvailableTexturePackListComponent
 
         public void render(int x, int y, int width, int mouseX, int mouseY, int index, boolean hovered) {
             Tessellator tessellator = Tessellator.instance;
-            FontRenderer fontRenderer = mc.fontRenderer;
+            Font font = mc.font;
 
             setupButton(x, y, width, mouseX, mouseY);
 
@@ -170,21 +170,21 @@ public class AvailableTexturePackListComponent
 
 			if(format == Global.TEXTURE_PACK_FORMAT) {
 				// Correct version
-				fontRenderer.drawString(texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				fontRenderer.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
-				fontRenderer.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
+				font.drawString(texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
+				font.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
+				font.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
 			}else if(format == -1) {
 				// Manifest error
-				fontRenderer.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				fontRenderer.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
-				fontRenderer.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
+				font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
+				font.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
+				font.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}else {
 				// Wrong texture pack version
 				I18n i18n = I18n.getInstance();
-				fontRenderer.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				fontRenderer.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + height + 2, y + 12, 0x808080);
-				fontRenderer.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + height + 2, y + 22, 0x808080);
+				font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
+				font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + height + 2, y + 12, 0x808080);
+				font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + height + 2, y + 22, 0x808080);
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}
 
@@ -194,8 +194,8 @@ public class AvailableTexturePackListComponent
             }
 
             String version = texturePack.manifest.getPackVersion();
-            int versionWidth = fontRenderer.getStringWidth(version);
-            fontRenderer.drawString(texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1, rgbVersion);
+            int versionWidth = font.getStringWidth(version);
+            font.drawString(texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1, rgbVersion);
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + width - button.width - 1);
diff --git a/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
index 360ff2052..c4264b813 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiSwitchButton;
+import net.minecraft.client.gui.SwitchElement;
 import net.minecraft.client.option.BooleanOption;
 
 public class BooleanOptionComponent
     extends ButtonComponent
 {
     private final BooleanOption option;
-    private final GuiSwitchButton button;
+    private final SwitchElement button;
 
     public BooleanOptionComponent(BooleanOption option)
     {
         super("options." + option.name);
 
         this.option = option;
-        this.button = new GuiSwitchButton(0, 0, 0, 150, 20, this.option.value, "", "");
+        this.button = new SwitchElement(0, 0, 0, 150, 20, this.option.value, "", "");
         this.button.setOn(this.option.value);
         this.button.displayString = this.option.getDisplayStringValue();
     }
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index fb765e2bf..f6ef7624a 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -20,12 +20,12 @@ public abstract class ButtonComponent
 
     private final String translationKey;
 
-    protected final GuiButton resetButton;
+    protected final ButtonElement resetButton;
 
     public ButtonComponent(String translationKey)
     {
         this.translationKey = translationKey;
-        this.resetButton = new GuiButton(0, 0, 0, 20, 20, "")
+        this.resetButton = new ButtonElement(0, 0, 0, 20, 20, "")
             .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
     }
 
@@ -42,7 +42,7 @@ public abstract class ButtonComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        FontRenderer fr = mc.fontRenderer;
+        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
diff --git a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index b592a19c0..0fd3d1677 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiSliderInteger;
+import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.EnumOption;
 import net.minecraft.client.option.enums.Difficulty;
 import net.minecraft.core.lang.I18n;
@@ -9,12 +9,12 @@ import net.minecraft.core.lang.I18n;
 public class DifficultyOptionComponent extends ButtonComponent {
 
     protected final EnumOption<Difficulty> option;
-    protected final GuiSliderInteger slider;
+    protected final IntegerSliderElement slider;
 
     public DifficultyOptionComponent(EnumOption<Difficulty> difficultyOption) {
         super("options." + difficultyOption.name);
         option = difficultyOption;
-        this.slider = new GuiSliderInteger(0, 0, 0, 150, 20, option);
+        this.slider = new IntegerSliderElement(0, 0, 0, 150, 20, option);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index 0f1f0e802..92b07cd86 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiSlider;
+import net.minecraft.client.gui.SliderElement;
 import net.minecraft.client.option.FloatOption;
 
 public class FloatOptionComponent
         extends ButtonComponent
 {
     private final FloatOption option;
-    private final GuiSlider slider;
+    private final SliderElement slider;
 
     public FloatOptionComponent(FloatOption option)
     {
         super("options." + option.name);
 
         this.option = option;
-        this.slider = new GuiSlider(0, 0, 0, 150, 20, this.option.getDisplayStringValue(), this.option.value);
+        this.slider = new SliderElement(0, 0, 0, 150, 20, this.option.getDisplayStringValue(), this.option.value);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
index 725ec1966..e6e32b63f 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.option.IntegerOption;
 
 public class IntegerOptionComponent
     extends ButtonComponent
 {
     private final IntegerOption option;
-    private final GuiButton button;
+    private final ButtonElement button;
 
     public IntegerOptionComponent(IntegerOption option)
     {
         super("options." + option.name);
 
         this.option = option;
-        this.button = new GuiButton(0, 0, 0, 150, 20, this.option.getDisplayString());
+        this.button = new ButtonElement(0, 0, 0, 150, 20, this.option.getDisplayString());
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java b/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
index 6a7e0db91..defa9a0ff 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
@@ -1,33 +1,33 @@
 package net.minecraft.client.gui.options.components;
 
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.options.GuiOptions;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.options.OptionsScreen;
 import net.minecraft.client.option.KeyBinding;
 
 public class KeyBindingComponent
         extends ButtonComponent
 {
     private final KeyBinding keyBinding;
-    private final GuiButton guiButton;
-    private final GuiButton clearButton;
+    private final ButtonElement keyButton;
+    private final ButtonElement clearButton;
 
     public KeyBindingComponent(KeyBinding keyBinding)
     {
         super(keyBinding.getId());
 
         this.keyBinding = keyBinding;
-        this.guiButton = new GuiButton(0, 0, 0, 150, 20, keyBinding.getKeyName());
-        this.clearButton = new GuiButton(0, 0, 0, 12, 20, "X");
+        this.keyButton = new ButtonElement(0, 0, 0, 150, 20, keyBinding.getKeyName());
+        this.clearButton = new ButtonElement(0, 0, 0, 12, 20, "X");
     }
 
     @Override
     protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
-        if (this.clearButton.mouseClicked(mc, this.clearButton.xPosition + (relativeMouseX - this.guiButton.width), this.clearButton.yPosition + relativeMouseY)) {
+        if (this.clearButton.mouseClicked(mc, this.clearButton.xPosition + (relativeMouseX - this.keyButton.width), this.clearButton.yPosition + relativeMouseY)) {
             this.keyBinding.unbind();
-            this.guiButton.displayString = this.keyBinding.getKeyName();
+            this.keyButton.displayString = this.keyBinding.getKeyName();
         } else {
-            GuiOptions.pickingKeyBinding = keyBinding;
-            GuiOptions.pickingKeyBindingComponent = this;
+            OptionsScreen.pickingKeyBinding = keyBinding;
+            OptionsScreen.pickingKeyBindingComponent = this;
         }
     }
 
@@ -36,14 +36,14 @@ public class KeyBindingComponent
     {
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
-        this.guiButton.xPosition = x + relativeButtonX;
-        this.guiButton.yPosition = y + relativeButtonY;
-        this.guiButton.width = buttonWidth - this.clearButton.width;
-        this.guiButton.height = buttonHeight;
+        this.keyButton.xPosition = x + relativeButtonX;
+        this.keyButton.yPosition = y + relativeButtonY;
+        this.keyButton.width = buttonWidth - this.clearButton.width;
+        this.keyButton.height = buttonHeight;
 
-        this.guiButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+        this.keyButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
-        this.clearButton.xPosition = x + relativeButtonX + this.guiButton.width;
+        this.clearButton.xPosition = x + relativeButtonX + this.keyButton.width;
         this.clearButton.yPosition = y + relativeButtonY;
         this.clearButton.enabled = this.keyBinding.isBound();
 
@@ -51,13 +51,13 @@ public class KeyBindingComponent
     }
 
     public void update() {
-        this.guiButton.displayString = this.keyBinding.getKeyName();
+        this.keyButton.displayString = this.keyBinding.getKeyName();
     }
 
     @Override
     public void resetValue() {
         keyBinding.resetToDefault();
-        guiButton.displayString = keyBinding.getKeyName();
+        keyButton.displayString = keyBinding.getKeyName();
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index 25f24d7a3..f5ab95fb5 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -1,12 +1,14 @@
 package net.minecraft.client.gui.options.components;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.lang.Language;
 import net.minecraft.core.lang.LanguageSeeker;
 import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.ArrayList;
@@ -17,6 +19,7 @@ import static net.minecraft.client.gui.options.components.ButtonComponent.mc;
 
 public class LanguagePackListComponent
     implements OptionsComponent {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final int BUTTON_HEIGHT = 32;
 
     private List<Language> languages = null;
@@ -38,7 +41,7 @@ public class LanguagePackListComponent
                 buttons.add(new LanguagePackComponent(i, language));
             }
         } catch (IOException e) {
-            e.printStackTrace();
+            LOGGER.error("Exception while getting available languages!", e);
         }
     }
 
@@ -83,7 +86,7 @@ public class LanguagePackListComponent
     }
 
     private static class LanguagePackComponent {
-    	private Minecraft mc = Minecraft.getMinecraft(this);
+    	private final Minecraft mc = Minecraft.getMinecraft(this);
         public final int index;
         public final Language languagePack;
         public final int height = BUTTON_HEIGHT;
@@ -94,7 +97,7 @@ public class LanguagePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
-            FontRenderer textRenderer = mc.fontRenderer;
+            Font textRenderer = mc.font;
             Tessellator tessellator = Tessellator.instance;
 
             if (mc.gameSettings.language.value.equals(languagePack.getId())) {
diff --git a/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java b/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
index 25d4b78ac..6cc34375a 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiRenderItem;
+import net.minecraft.client.gui.ItemElement;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -13,7 +13,7 @@ public class OptionsCategory
     implements OptionsComponent
 {
     private static final Minecraft mc = Minecraft.getMinecraft(OptionsCategory.class);
-    private static final GuiRenderItem renderItem = new GuiRenderItem(mc);
+    private static final ItemElement renderItem = new ItemElement(mc);
     private static final int PADDING = 2;
     private static final int TOP_SPACING = PADDING + 10 + 10 + PADDING;
     private static final int COMPONENT_LEFT_MARGIN = 16;
@@ -81,7 +81,7 @@ public class OptionsCategory
         {
             textColor = 0xFFFFA0;
         }
-        mc.fontRenderer.drawStringWithShadow((collapsed ? "▷" : "▽"), x, y + PADDING + 10, textColor);
+        mc.font.drawStringWithShadow((collapsed ? "▷" : "▽"), x, y + PADDING + 10, textColor);
 
         int xOffset = 10;
         if (icon != null)
@@ -89,7 +89,7 @@ public class OptionsCategory
             renderItem.render(icon, x + 11, y + PADDING + 5);
             xOffset += 20;
         }
-        mc.fontRenderer.drawStringWithShadow(i18n.translateKey(translationKey), x + xOffset, y + PADDING + 10, textColor);
+        mc.font.drawStringWithShadow(i18n.translateKey(translationKey), x + xOffset, y + PADDING + 10, textColor);
         if (!collapsed) {
             int componentY = TOP_SPACING;
             for (OptionsComponent component : components)
diff --git a/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java b/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
index 8949dec66..081d24638 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiTextField;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.options.data.OptionsPage;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.gui.text.TextFieldEditor;
@@ -14,12 +13,12 @@ import java.util.ArrayList;
 import java.util.List;
 
 public class SearchFieldComponent
-    implements OptionsComponent, GuiTextField.ITextChangeListener {
+    implements OptionsComponent, TextFieldElement.ITextChangeListener {
     private static final Minecraft mc = Minecraft.getMinecraft(SearchFieldComponent.class);
 
     private static final int PADDING = 4;
 
-    private final GuiTextField textField;
+    private final TextFieldElement textField;
     private final TextFieldEditor editor;
 
     private final List<OptionsComponent> components = new ArrayList<>();
@@ -27,14 +26,14 @@ public class SearchFieldComponent
     private OptionsComponent clickedComponent = null;
     private int clickedComponentY = 0;
 
-    private GuiButton clearButton;
+    private ButtonElement clearButton;
 
     public SearchFieldComponent() {
-        textField = new GuiTextField(null, mc.fontRenderer, 0, 0, 150, 18, "", "Search...");
+        textField = new TextFieldElement(null, mc.font, 0, 0, 150, 18, "", "Search...");
         textField.setMaxStringLength(20);
         textField.setTextChangeListener(this);
         editor = new TextFieldEditor(textField);
-        clearButton = new GuiButton(0, 0, 0, 12, 20, "X");
+        clearButton = new ButtonElement(0, 0, 0, 12, 20, "X");
     }
 
     @Override
@@ -129,7 +128,7 @@ public class SearchFieldComponent
     }
 
     @Override
-    public void textChanged(GuiTextField textField) {
+    public void textChanged(TextFieldElement textField) {
         updateSearchResults(textField.getText());
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index 1a3fa786a..9dc0737ca 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
@@ -64,7 +64,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (selectedPacks.isEmpty()) {
-            mc.fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
+            mc.font.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
         }
         for (TexturePackButton button : selectedPacks) {
             if (button == draggedButton) continue;
@@ -121,7 +121,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
     }
 
     private static class TexturePackButton {
-        private GuiButton button;
+        private ButtonElement button;
         public boolean draggable;
         public final TexturePack texturePack;
         public final int height = BUTTON_HEIGHT;
@@ -134,7 +134,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
             this.texturePack = texturePack;
             this.xPos = xPos;
             this.yPos = yPos;
-            button = new GuiButton(0, 0, 0, 20, 20, "-");
+            button = new ButtonElement(0, 0, 0, 20, 20, "-");
         }
 
         public boolean isClickable() {
@@ -207,7 +207,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
         public void render(SelectedTexturePackListComponent component, int x, int y, int width, int mouseX, int mouseY) {
             Tessellator tessellator = Tessellator.instance;
-            FontRenderer fontRenderer = mc.fontRenderer;
+            Font font = mc.font;
 
             setupButton(x, y, width, mouseX, mouseY);
 
@@ -257,21 +257,21 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
             if(format == Global.TEXTURE_PACK_FORMAT) {
                 // Correct version
-                fontRenderer.drawString(texturePack.manifest.getName(),             x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                fontRenderer.drawString(texturePack.manifest.getDescriptionLine1(), x + xPos + height + 2, y + yPos + 12, 0x808080);
-                fontRenderer.drawString(texturePack.manifest.getDescriptionLine2(), x + xPos + height + 2, y + yPos + 22, 0x808080);
+                font.drawString(texturePack.manifest.getName(),             x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
+                font.drawString(texturePack.manifest.getDescriptionLine1(), x + xPos + height + 2, y + yPos + 12, 0x808080);
+                font.drawString(texturePack.manifest.getDescriptionLine2(), x + xPos + height + 2, y + yPos + 22, 0x808080);
             }else if(format == -1) {
                 // Manifest error
-                fontRenderer.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                fontRenderer.drawString(texturePack.manifest.getDescriptionLine1(),          x + xPos + height + 2, y + yPos + 12, 0x808080);
-                fontRenderer.drawString(texturePack.manifest.getDescriptionLine2(),          x + xPos + height + 2, y + yPos + 22, 0x808080);
+                font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
+                font.drawString(texturePack.manifest.getDescriptionLine1(),          x + xPos + height + 2, y + yPos + 12, 0x808080);
+                font.drawString(texturePack.manifest.getDescriptionLine2(),          x + xPos + height + 2, y + yPos + 22, 0x808080);
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }else {
                 // Wrong texture pack version
                 I18n i18n = I18n.getInstance();
-                fontRenderer.drawString(TextFormatting.RED + texturePack.manifest.getName(),                            x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                fontRenderer.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"),  x + xPos + height + 2, y + yPos + 12, 0x808080);
-                fontRenderer.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"),  x + xPos + height + 2, y + yPos + 22, 0x808080);
+                font.drawString(TextFormatting.RED + texturePack.manifest.getName(),                            x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
+                font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"),  x + xPos + height + 2, y + yPos + 12, 0x808080);
+                font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"),  x + xPos + height + 2, y + yPos + 22, 0x808080);
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }
 
@@ -281,8 +281,8 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
             }
 
             String version = texturePack.manifest.getPackVersion();
-            int versionWidth = fontRenderer.getStringWidth(version);
-            fontRenderer.drawString(texturePack.manifest.getPackVersion(), x + xPos + width - versionWidth - 2, y + yPos + 1, rgbVersion);
+            int versionWidth = font.getStringWidth(version);
+            font.drawString(texturePack.manifest.getPackVersion(), x + xPos + width - versionWidth - 2, y + yPos + 1, rgbVersion);
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + xPos + width - button.width - 1);
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ShortcutComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ShortcutComponent.java
index aa26d6764..b77b61c1a 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ShortcutComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ShortcutComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 
@@ -12,13 +12,13 @@ public class ShortcutComponent
     private static final int BUTTON_WIDTH = 200;
 
     protected final String translationKey;
-    protected final GuiButton button;
+    protected final ButtonElement button;
     protected final Runnable action;
 
     public ShortcutComponent(String translationKey, Runnable action) {
         this.translationKey = translationKey;
         this.action = action;
-        this.button = new GuiButton(0, 0, 0, BUTTON_WIDTH, 20, "");
+        this.button = new ButtonElement(0, 0, 0, BUTTON_WIDTH, 20, "");
     }
 
     @Override
